%include "bios.h"
%include "dos.h"
%include "misc.h"

segment code
..start:
	;set up segment registers+stack
	push ds
	mov ax,data
	mov ds,ax
	pop word [PSPS]
	mov ax,stack
	mov ss,ax
	mov sp,stacktop

	;deallocate extra memory+calculate
	;original allocated space

	mov es,[PSPS]
	mov ax,[es:0x0002]
	sub ax,[PSPS]
	mov [OA],ax
	mov ah,0x4a
	mov bx,0x0400
	int 0x21

	jnc mnu	;if no error, skip error message
	m_BiosSimpleCLS
	mov dx,msgNM
	call DspStr
	mov dx,msgPK
	call DspStr
RdA:	m_DosReadKeyboard
	cmp al,0x00
	je RdA
mnu:	m_BiosSimpleCLS
	mov dx, msgTS1
	call DspStr
mnulp:	m_DosReadKeyboard
	cmp al,0x00
	jne skipSN
	m_DosReadKeyboard
	jmp short mnulp
skipSN:	cmp al,'1' ;Key>ASCII
	jne skKA
	m_BiosSimpleCLS
	mov dx,msgmnu
	call DspStr
KAloop:	m_DosReadKeyboard
	push ax
	m_DosDisplayCharacter al ;this destroys AL
	mov dl,'='
	int 0x21 ;another m_DosDisplayCharacter
	pop ax
	xor ah,ah ;AL has the character number
	push ax
	call DspAX
	mov dx,msgcr
	call DspStr
	pop ax
	inc ah
	xor dx,dx
	int 0x14
	jmp short KAloop
skKA:	cmp al,'2' ;Clock
	je doCL
	jmp skCL
doCL:	m_BiosSimpleCLS
	mov dx,msgCL
	call DspStr
LB:	hlt ;saves battery power (maybe)
	m_DosGetTime
	push dx
	m_BiosSimpleLocate 0x0000
	cmp ch,0x0a
	jge skipH
	m_DosDisplayCharacter '0'
skipH:	push cx
	xor ax,ax
	mov al,ch
	call DspAX
	pop cx
	m_BiosSimpleLocate 0x0003
	cmp cl,0x0a
	jge skipM
	m_DosDisplayCharacter '0'
skipM:	xor ax,ax
	mov al,cl
	call DspAX
	pop cx

	m_BiosSimpleLocate 0x0006
	cmp ch,0x0a
	jge skipS
	m_DosDisplayCharacter '0'
skipS:	push cx
	xor ax,ax
	mov al,ch
	call DspAX
	pop cx

	m_BiosSimpleLocate 0x0009
	cmp cl,0x0a
	jge skipD
	m_DosDisplayCharacter '0'
skipD:	xor ax,ax
	mov al,cl
	call DspAX
KBD:	m_DosCheckKeyboardStatus
	cmp al,0x00
	je JF
CLRK:	m_DosReadKeyboard
	cmp al,0x00
	je CLRK
	jmp mnu
	jmp short KBD
JF:	jmp LB
skCL:	cmp al,'3' ;Info
	je doIN
	jmp skIN
doIN:	m_BiosSimpleCLS
	mov dx,msgCS
	call DspStr
	mov ax,cs
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgDS
	call DspStr
	mov ax,ds
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgSS
	call DspStr
	mov ax,ss
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgPSP
	call DspStr
	mov ax,[PSPS]
	mov es,ax
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgENV
	call DspStr
	mov ax,[es:0x002c]
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgOA
	call DspStr
	mov ax,[OA]
	call DspAXh
	mov dx,msgOA2
	call DspStr
	mov dx,msgPK
	call DspStr
INRK:	m_DosReadKeyboard
	cmp al,0x00
	je INRK
	jmp mnu
skIN:	cmp al,'4' ;Exit to DOS
	jne skEX
	m_BiosSimpleCLS
	int 0x23
EXEX:	jmp mnu
skEX:	cmp al,'5' ;Port Util.
	je doPU
	jmp skPU
doPU:	xor bx,bx
PURF:	m_BiosSimpleCLS
	;draw the screen
	push bx
	m_BiosSimpleLocate 0x0600
	mov dx,msgPU1
	call DspStr
	pop bx
PUSBL:	mov cx,6 ;update 6 lines
PUDL:	mov dh,cl
	dec dh
	xor dl,dl
	push bx
	xor bh,bh
	mov ah,0x02
	int 0x10
	pop bx
	mov ax,bx
	dec ax
	add ax,cx
	push BX
	push CX
	call DspAXh
	m_DosDisplayCharacter '='
	pop CX
	pop BX
	loop PUDL
PUDV:	;display values

	mov cx,6 ;update 6 lines
PUUL:	mov dh,cl
	dec dh
	mov dl,0x05
	push bx
	xor bh,bh
	mov ah,0x02
	int 0x10
	pop bx
	mov dx,bx
	dec dx
	add dx,cx
	in al,dx
	push BX
	push CX
	call DspALh
	pop CX
	pop BX
	loop PUUL
	m_DosCheckKeyboardStatus
	or al,al
	jz PUDV
	m_DosReadKeyboard
	or al,al
	jnz PUNNK
	jmp PUNK
	;should be a number now
PUNNK:	cmp al,'0'
	jne PUNEX ;continue
	jmp mnu
PUNEX	cmp al,'1'
	jne PUS1
	mov cx,0001
	push bx
	m_BiosSimpleLocate 0x0600
	mov dx,msgPU2
	call DspStr
	m_BiosSimpleLocate 0x0708
	call GetAXh
	pop bx
	or cl,cl
	jnz PUSNA
	jmp short jPURF
PUSNA:	mov bx,ax
	jmp short jPURF
PUS1:	cmp al,'2'
	jne PUDV
PUGWA:	mov cx,0001
	push bx
	m_BiosSimpleLocate 0x0600
	mov dx,msgPU3
	call DspStr
	m_BiosSimpleLocate 0x0708
	call GetAXh
	pop bx
	or cl,cl
	jnz PUGWB
	jmp short jPURF
PUGWB:	mov si,ax
	mov ch,00
	push bx
	mov dx,msgPU4
	call DspStr
	call GetALh
	pop bx
	or cl,cl
	jz PUGWA
	push si
	pop dx
	out dx,al
jPURF:	jmp PURF
	
PUNK:	m_DosReadKeyboard
	cmp al,72
	jne PUS72
	dec bx
	jmp short jPUSBL
PUS72:	cmp al,80
	jne PUS80
	inc bx
	jmp short jPUSBL
PUS80:	cmp al,75
	jne PUS75
	sub bx,0x0006
	jmp short jPUSBL
PUS75:	cmp al,77
	jne jPUSBL
	add bx,0x0006
jPUSBL:	jmp PUSBL
PUEX:	jmp mnu
skPU:	cmp al,'6' ;About
	jne skAB
	m_BiosSimpleCLS
	mov dx,msgTS2
	call DspStr
lpAB:	m_DosReadKeyboard
	cmp al,0x00
	je lpAB ;ignore the null on an extended key
	jmp short PUEX ;jump to menu
skAB:	cmp al,'7' ;Memory Search
	je doME
	jmp skME
doME:	m_BiosSimpleCLS
	


MEEX:	jmp mnu
skME:	cmp al,'8' ;Graphics
	jne MEEX
	mov ax,0x0004
	int 0x10
	mov dx,0001
lpGR:	mov cx,128
lpGR2:	push cx
	push dx
	dec dx
	dec cx
	mov ax,cx
	mul dx
	test ah,0x04
	jz GRND
	mov al,0x01
	pop dx
	push dx
	dec dx
	call PxlWr
GRND:	pop dx
GRD:	pop cx
	loop lpGR2
	inc dx
	cmp dx,65
	jne lpGR
	jmp lpAB


DspAX:	m_DisplayNumberAX
	ret
DspAXh:	m_DisplayNumberAXh
	ret
DspALh:	m_DisplayNumberALh
	ret
GetAXh:	m_GetNumberAXh
	ret
GetALh:	m_GetNumberALh
	ret
DspStr:	pusha
	mov si,dx
	m_FastDisplayString
	popa
	ret
PxlWr:	pusha
	m_BiosPixelWrite
	popa
	ret
PxlRe:	push bx
	m_BiosPixelRead
	pop bx
	ret
segment data
msgTS1:	db 'Welcome to ASMTest1',0x0d,0x0a
	db 'for CASIO AFX 2.0',0x0d,0x0a
	db '1-Key>ASCII   2-Clock'
	db '3-Info  4-Exit to DOS'
	db '5-Port Util.  6-About'
	db '7-Mem. Util.   8-Gfx.',0x0d,0x0a
	db 'MENU-Exit$'
msgTS2:	db ' About ASMTest1 by',0x0d,0x0a
	db ' Brad Normand-2001:',0x0d,0x0a
	db 0x0d,0x0a
	db 'Thanx to dscoshpe for'
	db 'some information used'
	db 'in this-Visit CALiPSO'
	db 'at ccp.s5.com!',0x0d,0x0a
msgPK:	db 'Press a key$'
msgNM:	db 'DOS error freeing',0x0d,0x0a
	db 'excess memory.',0x0d,0x0a,'$'
msgCMD:	db 'Starting miniCMD...',0x0d,0x0a,'$'
msgCL:	db '--:--:--.--',0x0d,0x0a
PK2X:	db 'Press a key to exit$'
msgmnu: db 'Hit MENU key to exit'
msgcr:	db 0x0d,0x0a,'$'
msgCS:	db ' CS=$'
msgDS:	db ' DS=$'
msgSS:	db ' SS=$'
msgPSP:	db 'PSP=$'
msgENV:	db 'ENV=$'
msgOA:	db 'Originally allocated',0x0d,0x0a,'$'
msgOA2:	db ' paragraphs.',0x0d,0x0a,'$'
msgPU1:	db 'Arrows move, 0=exit',0x0d,0x0a
	db '1=set addr, 2=write$'
msgPU2:	db 'Enter new hex start',0x0d,0x0a
	db 'offset:            $'
msgPU3:	db 'Enter hex write addr',0x0d,0x0a
	db 'offset:            $'
msgPU4:	db ' byte:$'
CMDNme:	db 'COMMAND.COM',0x00
pblk:	dw 0x0000
	dw seg cmdln,cmdln
	dw seg dummy,dummy,seg dummy,dummy
cmdln:	db 0x03,' /P',0x0d
PSPS:	dw 0x0000
OA:	dw 0x0000
dummy:	times 0x14 db 0x00

segment stack stack
	resb 0x100
stacktop: