;FOR MORE INFORMATION:
; go to http://www.delorie.com/djgpp/doc/rbinter
; for Ralph Brown's interrupt list


%macro m_BiosSimpleCLS 0
	;clears the screen to 80x25 text mode (21x8 on calc)
	;should preserve all registers
	push ax
	mov ax,0x0002
	int 0x10
	pop ax
%endmacro

%macro m_BiosSimpleLocate 1
	;moves the cursor to 0xRRCC of the parameter,
	;where RR is the row, and CC is the column
	;registers AH, BH, and DX are destroyed

	mov ah,0x02
	mov dx,%1
	mov bh,0x00
	int 0x10
%endmacro

%macro m_BiosPixelWrite 0
	;writes the pixel value in AL to column CX row DX
	;for PC compatability you must switch to a graphics
	;mode first, but the calc might allow running these
	;without first entering a graphics mode
	;registers AH, and BX are destroyed
	xor bx,bx
	mov ah,0x0c
	int 0x10
%endmacro

%macro m_BiosPixelRead 0
	;reads the pixel value to AL from column CX row DX
	;same as previous macro, except this one reads to AH
	xor bx,bx
	mov ah,0x0d
	int 0x10
%endmacro